/*
 * File: IsPrime.c
 *
 * Author: M. I. Karavelas
 * Class:  EM101 / Fall Semester 2008
 */

#include "IsPrime.h"
#include <math.h>

/*
 * Function: IsPrime
 * Usage: if ( IsPrime(n) )
 * ------------------------
 * Returns TRUE if the given number is prime, FALSE otherwise.
 *
 * The function works as follows:
 * After checking the easy cases (i.e., whether n is 2 or some other
 * even number), then for each integer k from 3 to ceiling of sqrt(n),
 * excluding multiples of 2, compute the remainder of the division of
 * n with k. If a zero remainder is found return that the number is
 * prime, otherwise return that the number is not prime.
 */

bool IsPrime(unsigned int n)
{
  unsigned int k, kmax;
  double sqrt_n;

  if ( n == 2 ) { return TRUE; }
  if ( n % 2 == 0 ) { return FALSE; }

  /* compute ceil(sqrt(n)) and assign it to kmax */
  sqrt_n = sqrt((double)n);
  if ( ((int)sqrt_n) == sqrt_n ) {
    kmax = sqrt_n;
  } else {
    kmax = (int)sqrt_n + 1;
  }

  for (k = 3; k <= kmax; k += 2) {
    if ( n % k == 0 ) { return FALSE; }
  }

  return TRUE;
}
